<template lang="pug">
  div.lc-live-hub
    div.ui.container
      h1.centered Livestream Hub
      p.subtitle.centered The list of currently active streams on LC's Javelin server.
      div.ui.segment.inverted
        div.lc-live-loading(v-if="loading")
          p.ui.row
            i.sync.icon
            |  Please wait while we fetch who's currently online...
          div.ui.placeholder.inverted
            div.image.header
              div.line
              div.line

        div.lc-live-empty(v-else-if="empty")
          i.power.off.icon
          |  Nobody is livestreaming at the moment.

        div.lc-live-online(v-else)
          p.ui.row
            i.tv.icon
            |  There {{streams.length === 1 ? "is" : "are"}} {{streams.length}} livestream{{streams.length === 1 ? "" : "s"}} online.
          div.ui.comments.inverted
            router-link(v-for="stream in streams" :key="stream.name" :to="'/javelin/live/' + stream.name")
              livestream-card(
                :avatar="stream.avatar"
                :name="stream.name"
                :ok="stream.ok"
                :startTime="stream.stats.start_time"
                :metadata="stream.stats.metadata"
              )
</template>

<script lang="ts">
import { Component, Vue } from 'vue-property-decorator'

import LivestreamCard from '@/comps/LivestreamCard.vue'

import 'semantic-ui-css/components/container.min.css'
import 'semantic-ui-css/components/segment.min.css'
import 'semantic-ui-css/components/placeholder.min.css'
import 'semantic-ui-css/components/icon.min.css'
import 'semantic-ui-css/components/comment.min.css'
import 'semantic-ui-css/components/image.min.css'
import 'semantic-ui-css/components/grid.min.css'

import LuciaCoreAPI, { ActiveStreamsResponse, StreamStatsResponse } from '@/data/api'
import images from '@/data/images'

interface StreamStats extends StreamStatsResponse {
  elapsed: string
}

interface StreamInformation {
  ok: boolean
  name: string
  avatar: string
  stats: StreamStats | object
}

@Component({ components: { LivestreamCard } })
export default class LCLiveHub extends Vue {
  loading = true
  empty = false
  streams: StreamInformation[] = []
  images = images

  mounted () {
    const self = this
    const api = new LuciaCoreAPI()

    self.loading = true

    api.getActiveStreams()
      .then((activeStreams) => {
        activeStreams.streams.forEach(name => {
          const stream = {
            ok: false,
            name,
            avatar: images.avatars[name] ? images.avatars[name] : images.core.lcUnknownUser,
            stats: {}
          }

          api.getStream(name)
            .then((stats) => {
              stream.ok = true
              stream.stats = { ...stats }
            })

          self.streams.push(stream)
        })

        self.loading = false
        self.empty = self.streams.length === 0
      })
      .catch(() => { self.loading = false })
  }
}
</script>

<style lang="stylus">
.ui.comments .comment .author.streamer, .ui.comments .comment .metadata .text.elapsed, .ui.comments .comment .text.description
  color: rgba(255, 255, 255, 0.9)

.ui.comments .comment a.author.streamer:hover
  color: #8000ff

.ui.comments.inverted
  max-width: unset
</style>
